// this is a test file for a 16f628
// flash led on portb bit 0
// the reset pin is configured to function as a reset pin and not an io pin
// compile with picclite compiler -->  http://www.hitech.com.au/ 

#include	<pic.h>

typedef unsigned int word;
typedef unsigned char byte;

void delay_ms(word ms);

// config word
__CONFIG(INTIO & BORDIS & WDTDIS & PWRTEN & MCLRIO);
// __CONFIG(INTIO & BORDIS & WDTDIS & PWRTEN);

void main()
{
   TRISB0 = 0;
   RB0 = 1;

   while(1)
   {
      delay_ms(500);

      if (RB0 == 0)
         RB0 = 1;
      else
         RB0 = 0;
   }
}

// this is OK upto 4MHz
// add more nops above 4MHz
// compile with -O -Zg
//
#define XTAL 4000000

#define DELAY_CNTR (XTAL/4/4/1000-2)

void delay_ms(word ms)
{
   byte i;

   while(ms--)
   {
      for (i = DELAY_CNTR; i > 0; i--)
      {
         asm("nop");
      }
   }
}
